package com.abi.qms.platform;

import com.abi.qms.platform.dto.res.GetPackageCodeRes;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.boot.test.context.SpringBootTest;

import java.lang.reflect.Field;
import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.Map;

@SpringBootTest
@Slf4j
public class ReactBeanTest {

    public static void main(String[] args) {
        Class clz = GetPackageCodeRes.class;

        Map<Class,String> classMap = new HashMap<>();
        classMap.put(String.class,"string");
        classMap.put(LocalDateTime.class,"string");
        classMap.put(Long.class,"string");
        classMap.put(Integer.class,"number");

        StringBuffer sb = new StringBuffer();

        Field[] declaredFields = clz.getDeclaredFields();
        for(Field field:declaredFields){
            ApiModelProperty apiModelProperty = field.getAnnotation(ApiModelProperty.class);
            String desc = apiModelProperty==null?"":apiModelProperty.value();
            if(StringUtils.isBlank(desc)){
                Schema schema = field.getAnnotation(Schema.class);
                desc = schema==null?"":schema.name();
            }

//            System.out.println(field.getName());
//            System.out.println(classMap.get(field.getType()));
//            System.out.println(desc);

            sb.append(String.format("// %s\n",desc));
            sb.append(String.format("%s: %s;\n",field.getName(),classMap.get(field.getType())));
        }
        System.out.println(sb.toString());
    }


}
